// ==UserScript==
// @name            BetterYTM
// @homepageURL     https://github.com/Sv443/BetterYTM#readme
// @namespace       https://github.com/Sv443/BetterYTM
// @version         1.0.0
// @description     Configurable layout and UX improvements for YouTube Music
// @description:de  Konfigurierbares Layout und UX-Verbesserungen für YouTube Music
// @license         MIT
// @author          Sv443
// @copyright       Sv443 (https://github.com/Sv443)
// @match           https://music.youtube.com/*
// @match           https://www.youtube.com/*
// @icon            https://raw.githubusercontent.com/Sv443/BetterYTM/main/resources/icon/icon.png
// @run-at          document-start
// @grant           GM.getValue
// @grant           GM.setValue
// @connect         self
// @connect         youtube.com
// @connect         github.com
// @connect         githubusercontent.com
// @downloadURL     https://raw.githubusercontent.com/Sv443/BetterYTM/main/dist/BetterYTM.user.js
// @updateURL       https://raw.githubusercontent.com/Sv443/BetterYTM/main/dist/BetterYTM.user.js
// ==/UserScript==
/*
 ▄▄▄                    ▄   ▄▄▄▄▄▄   ▄
 █  █ ▄▄▄ █   █   ▄▄▄ ▄ ▄█ █  █  █▀▄▀█
 █▀▀▄ █▄█ █▀  █▀  █▄█ █▀  █   █  █   █
 █▄▄▀ ▀▄▄ ▀▄▄ ▀▄▄ ▀▄▄ █   █   █  █   █

         Made with ❤️ by Sv443
 I welcome every contribution on GitHub!
   https://github.com/Sv443/BetterYTM
*/

/* Disclaimer: I am not affiliated with YouTube, Google, Alphabet, Genius or anyone else */
/* C&D this 🖕 */

!function(){"use strict";var e={546:function(e,t){var n=function(){function e(){this._eventHandlers={}}return e.prototype.isValidType=function(e){return"string"==typeof e},e.prototype.isValidHandler=function(e){return"function"==typeof e},e.prototype.on=function(e,t){if(!e||!t)return!1;if(!this.isValidType(e))return!1;if(!this.isValidHandler(t))return!1;var n=this._eventHandlers[e];return n||(n=this._eventHandlers[e]=[]),!(n.indexOf(t)>=0||(t._once=!1,n.push(t),0))},e.prototype.once=function(e,t){if(!e||!t)return!1;if(!this.isValidType(e))return!1;if(!this.isValidHandler(t))return!1;var n=this.on(e,t);return n&&(t._once=!0),n},e.prototype.off=function(e,t){if(!e)return this.offAll();if(t){if(this.isValidType(e)&&this.isValidHandler(t)){var n=this._eventHandlers[e];if(n&&n.length)for(var o=0;o<n.length;o++)if(n[o]===t){n.splice(o,1);break}}}else this._eventHandlers[e]=[]},e.prototype.offAll=function(){this._eventHandlers={}},e.prototype.fire=function(e,t){if(e&&this.isValidType(e)){var n=this._eventHandlers[e];if(n&&n.length)for(var o=this.createEvent(e,t),i=0,r=n;i<r.length;i++){var l=r[i];this.isValidHandler(l)&&(l._once&&(o.once=!0),l(o),o.once&&this.off(e,l))}}},e.prototype.has=function(e,t){if(!e||!this.isValidType(e))return!1;var n=this._eventHandlers[e];return!(!n||!n.length||t&&this.isValidHandler(t)&&!(n.indexOf(t)>=0))},e.prototype.getHandlers=function(e){return e&&this.isValidType(e)&&this._eventHandlers[e]||[]},e.prototype.createEvent=function(e,t,n){return void 0===n&&(n=!1),{type:e,data:t,timestamp:Date.now(),once:n}},e}();t.vp=n,new n}},t={};function n(o){var i=t[o];if(void 0!==i)return i.exports;var r=t[o]={exports:{}};return e[o](r,r.exports,n),r.exports}!function(){const e=!0,t=25,o=200,i=Object.freeze({name:GM.info.script.name,version:GM.info.script.version,namespace:GM.info.script.namespace,lastCommit:"78752be"});function r(){const{hostname:e}=new URL(location.href);if(e.includes("music.youtube"))return"ytm";if(e.includes("youtube"))return"yt";throw new Error("BetterYTM is running on an unexpected website. Please don't tamper with the @match directives in the userscript header.")}function l(e,t){var n;return null===(n=e.parentNode)||void 0===n||n.insertBefore(t,e.nextSibling),t}function s(t,n){"string"==typeof n&&0!==n.length||(n=String(Math.floor(1e4*Math.random())));const o=document.createElement("style");o.id=`betterytm-style-${n}`,o.innerHTML=t,document.head.appendChild(o),e&&console.log(`BetterYTM: Inserted global style with ref '${n}':`,o)}const a=new(n(546).vp);let c=null;function d(t){var n,o;if(["ArrowLeft","ArrowRight"].includes(t.code)){if(["INPUT","TEXTAREA","SELECT"].includes(null!==(o=null===(n=document.activeElement)||void 0===n?void 0:n.tagName)&&void 0!==o?o:"_"))return e&&console.info(`BetterYTM: Captured valid key but the current active element is <${document.activeElement.tagName.toLowerCase()}>, so the keypress is ignored`);e&&console.log(`BetterYTM: Captured key '${t.code}' in proxy listener`);const i={altKey:!1,ctrlKey:!1,metaKey:!1,shiftKey:!1,target:document.body,currentTarget:document.body,originalTarget:document.body,explicitOriginalTarget:document.body,srcElement:document.body,type:"keydown",bubbles:!0,cancelBubble:!1,cancelable:!0,isTrusted:!0,repeat:!1,view:window};let r=!1,l={};switch(t.code){case"ArrowLeft":l={code:"KeyH",key:"h",keyCode:72,which:72};break;case"ArrowRight":l={code:"KeyL",key:"l",keyCode:76,which:76};break;default:r=!0}if(r)e&&console.warn(`BetterYTM: Captured key '${t.code}' has no defined behavior`);else{const n=Object.assign(Object.assign({code:""},i),l);document.body.dispatchEvent(new KeyboardEvent("keydown",n)),e&&console.log(`BetterYTM: Dispatched proxy keydown event: [${t.code}] -> [${n.code}]`)}}}let u=!0;function m(){u=!1,e&&console.info("BetterYTM: Disabled popup before leaving the site")}var y=function(e,t,n,o){return new(n||(n=Promise))((function(i,r){function l(e){try{a(o.next(e))}catch(e){r(e)}}function s(e){try{a(o.throw(e))}catch(e){r(e)}}function a(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(l,s)}a((o=o.apply(e,t||[])).next())}))};const p=e?"develop":"main";function f(){const e=document.querySelector("#betterytm-menu-bg");e.style.visibility="hidden",e.style.display="none"}let h;let b=0;function g(){const n=document.querySelector('.ytmusic-nav-bar ytmusic-pivot-bar-item-renderer[tab-id="SPunlimited"]');n?(n.remove(),e&&console.log(`BetterYTM: Removed upgrade tab after ${b} tries`)):b<t?(setTimeout(g,o),b++):console.error(`BetterYTM: Couldn't find upgrade tab to remove after ${b} tries`)}function v(){const{volumeSliderSize:e}=h;"number"!=typeof e||isNaN(Number(e))||s(`.volume-slider.ytmusic-player-bar, .expand-volume-slider.ytmusic-player-bar {\n  width: ${e}px !important;\n}`,"vol-slider")}function w(){document.querySelector("tp-yt-paper-slider#volume-slider").setAttribute("step",String(h.volumeSliderStep))}function x(e){const t=document.createElement("div");t.className="bytm-queue-btn-container",t.innerText="ayo",e.querySelector(".song-info").appendChild(t),e.classList.add("bytm-has-queue-btns")}var T=function(e,t,n,o){return new(n||(n=Promise))((function(i,r){function l(e){try{a(o.next(e))}catch(e){r(e)}}function s(e){try{a(o.throw(e))}catch(e){r(e)}}function a(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(l,s)}a((o=o.apply(e,t||[])).next())}))},k=function(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t,n=e[Symbol.asyncIterator];return n?n.call(e):(e="function"==typeof __values?__values(e):e[Symbol.iterator](),t={},o("next"),o("throw"),o("return"),t[Symbol.asyncIterator]=function(){return this},t);function o(n){t[n]=e[n]&&function(t){return new Promise((function(o,i){!function(e,t,n,o){Promise.resolve(o).then((function(t){e({value:t,done:n})}),t)}(o,i,(t=e[n](t)).done,t.value)}))}}};const S="https://api.sv443.net/geniurl",E=`${S}/search/top`;let M="",C=0;function $(){return T(this,void 0,void 0,(function*(){const n=document.querySelector(".middle-controls-buttons ytmusic-like-button-renderer#like-button-renderer");if(!n)return C++,C<t?setTimeout($,o):console.error(`BetterYTM: Couldn't find element to append lyrics buttons to after ${C} tries`);const i=document.querySelector(".content-info-wrapper > yt-formatted-string"),r=yield B(),s=document.createElement("a");s.id="betterytm-lyrics-button",s.className="ytmusic-player-bar",s.title=r?"Click to open this song's lyrics in a new tab":"Loading...",r&&(s.href=r),s.target="_blank",s.rel="noopener noreferrer",s.style.visibility=r?"initial":"hidden",s.style.display=r?"inline-flex":"none";const a=document.createElement("img");a.id="betterytm-lyrics-img",a.src="https://raw.githubusercontent.com/Sv443/BetterYTM/main/resources/external/genius.png",s.appendChild(a),e&&console.log(`BetterYTM: Inserted genius button after ${C} tries:`,s),l(n,s),M=i.title,new MutationObserver((t=>{var n,o,i;return T(this,void 0,void 0,(function*(){var r,l,s,a;try{for(n=!0,o=k(t);!(r=(i=yield o.next()).done);){a=i.value,n=!1;try{const t=a.target.title;if(t!=M&&t.length>0){const n=document.querySelector("#betterytm-lyrics-button");if(!n)return;e&&console.log(`BetterYTM: Song title changed from '${M}' to '${t}'`),n.style.cursor="wait",n.style.pointerEvents="none",M=t;const o=yield B();if(!o)continue;n.href=o,n.title="Click to open this song's lyrics in a new tab",n.style.cursor="pointer",n.style.visibility="initial",n.style.display="inline-flex",n.style.pointerEvents="initial"}}finally{n=!0}}}catch(e){l={error:e}}finally{try{n||r||!(s=o.return)||(yield s.call(o))}finally{if(l)throw l.error}}}))})).observe(i,{attributes:!0,attributeFilter:["title"]})}))}function B(){var e,t;return T(this,void 0,void 0,(function*(){try{const n="string"==typeof(null===(e=document.querySelector("ytmusic-player"))||void 0===e?void 0:e.getAttribute("video-mode_")),o=document.querySelector(".content-info-wrapper > yt-formatted-string"),i=document.querySelector("span.subtitle > yt-formatted-string:first-child");if(!o||!i||!o.title)return null;const r=e=>e.replace(/\(.+\)/gim,"").replace(/\[.+\]/gim,"").trim(),l=e=>((e=e.split(/\s*\u2022\s*/gimu)[0]).match(/&/)&&(e=e.split(/\s*&\s*/gm)[0]),e.match(/,/)&&(e=e.split(/,\s*/gm)[0]),e.trim()),s=r(o.title),a=l(i.title),c=()=>T(this,void 0,void 0,(function*(){if(!s.includes("-"))return yield L(a,s);const[e,...t]=s.split("-").map((e=>e.trim()));return yield L(e,t.join(" "))}));return n?yield c():null!==(t=yield L(a,s))&&void 0!==t?t:yield c()}catch(e){return console.error("BetterYTM: Couldn't resolve genius.com URL:",e),null}}))}function L(t,n){return T(this,void 0,void 0,(function*(){try{const o=`${E}?artist=${encodeURIComponent(t)}&song=${encodeURIComponent(n)}`;e&&console.log(`BetterYTM: Requesting URL from geniURL at '${o}'`);const i=yield(yield fetch(o)).json();if(i.error)return void console.error("BetterYTM: Couldn't fetch genius.com URL:",i.message);const r=i.url;return e&&console.info(`BetterYTM: Found genius URL: ${r}`),r}catch(e){return void console.error("BetterYTM: Couldn't get genius URL due to error:",e)}}))}const Y={options:"bytm-menu-tab-options",info:"bytm-menu-tab-info",changelog:"bytm-menu-tab-changelog"};let O=0;function q(){var e;if(!document.querySelector("#bytm-menu-dialog"))return O++<t?setTimeout(q,o):console.error(`BetterYTM: couldn't create menu element after ${t} tries.`);for(const t in Y){const n=Y[t];null===(e=document.querySelector(`#${n}-header`))||void 0===e||e.addEventListener("click",(()=>{_(t)}))}document.querySelector("#bytm-menu-tab-options-content"),document.querySelector("#bytm-menu-tab-info-content"),document.querySelector("#bytm-menu-tab-changelog-content").innerHTML='<h1 id="betterytm-changelog">BetterYTM Changelog</h1> <br> <h2 id="history">History:</h2> <ul> <li><strong><a href="#100">v1.0.0</a></strong></li> <li><a href="#020">v0.2.0</a></li> <li><a href="#010">v0.1.0</a></li> </ul> <hr> <p><br><br></p> <h2 id="100">1.0.0</h2> <ul> <li>Added menu to configure features</li> <li>New configurable features:<ul> <li>Make volume slider bigger</li> <li>Choose step of volume slider for finer control</li> <li>TODO: Add lyrics button to each song in a playlist</li> </ul> </li> <li>Changes / Fixes:<ul> <li>Now the lyrics button will directly link to the lyrics (using my API <a href="https://github.com/Sv443/geniURL">geniURL</a>)</li> <li>TODO: Site switch with <kbd>F9</kbd> will now keep the video time</li> </ul> </li> </ul> <br> <h2 id="020">0.2.0</h2> <ul> <li>Added Features:<ul> <li>Switch between YouTube and YT Music (with <kbd>F9</kbd> by default)</li> <li>Search for song lyrics with new button in media controls</li> <li>Remove &quot;Upgrade to YTM Premium&quot; tab</li> </ul> </li> </ul> <br> <h2 id="010">0.1.0</h2> <ul> <li>Added support for arrow keys to skip forward or backward (currently only by fixed 10 second interval)</li> </ul> <p><br><br><br><br><br><br><br><br><br></p> '}function _(e){const t=Object.assign({},Y);delete t[e];for(const e of Object.keys(t))document.querySelector(`#${t[e]}-header`).dataset.active="false",document.querySelector(`#${t[e]}-content`).dataset.active="false";document.querySelector(`#${Y[e]}-header`).dataset.active="true",document.querySelector(`#${Y[e]}-content`).dataset.active="true"}const N=Object.freeze({arrowKeySupport:{desc:"Arrow keys skip forwards and backwards by 10 seconds",type:"toggle",category:"input",default:!0},switchBetweenSites:{desc:"Add F9 as a hotkey to switch between the YT and YTM sites on a video / song",type:"toggle",category:"input",default:!0},switchSitesHotkey:{desc:"Which hotkey needs to be pressed to switch sites?",type:"hotkey",category:"input",default:{key:"F9",shift:!1,ctrl:!1,meta:!1}},disableBeforeUnloadPopup:{desc:"Whether to completely disable the popup that sometimes appears before leaving the site",type:"toggle",category:"input",default:!1},anchorImprovements:{desc:"TODO: Make it so middle clicking a song to open it in a new tab is easier",type:"toggle",category:"input",default:!0},removeUpgradeTab:{desc:'Remove the "Upgrade" / YT Music Premium tab',type:"toggle",category:"layout",default:!0},volumeSliderSize:{desc:"The width of the volume slider in pixels",type:"number",category:"layout",min:10,max:1e3,step:5,unit:"px",default:160},volumeSliderStep:{desc:"Volume slider sensitivity - the smaller this number, the finer the volume control",type:"slider",category:"layout",min:1,max:20,default:2},watermarkEnabled:{desc:`Show a ${i.name} watermark under the YTM logo`,type:"toggle",category:"layout",default:!0},queueButtons:{desc:"TODO: Add buttons while hovering over a song in a queue to quickly remove it or open its lyrics",type:"toggle",category:"layout",default:!0},dismissPopup:{desc:'TODO: Automatically dismisses the "are you still there" popup',type:"toggle",category:"layout",default:!0},geniusLyrics:{desc:"Add a button to the media controls to open the current song's lyrics on genius.com in a new tab",type:"toggle",category:"lyrics",default:!0}});var A=function(e,t,n,o){return new(n||(n=Promise))((function(i,r){function l(e){try{a(o.next(e))}catch(e){r(e)}}function s(e){try{a(o.throw(e))}catch(e){r(e)}}function a(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(l,s)}a((o=o.apply(e,t||[])).next())}))};const R=Object.keys(N).reduce(((e,t)=>(e[t]=N[t].default,e)),{});let j;function H(e=!1){return A(this,void 0,void 0,(function*(){return(void 0===j||e)&&(yield I(j=Object.assign(Object.assign({},R),yield function(){return A(this,void 0,void 0,(function*(){const e=Object.freeze(Object.assign({},R));try{const t=yield GM.getValue("betterytm-config");return"string"!=typeof t?(yield U(),j=e):Object.freeze(t?JSON.parse(t):{})}catch(t){return yield U(),j=e}}))}()))),j}))}function I(e){if(!e||"object"!=typeof e)throw new TypeError("Feature config not provided or invalid");return j=Object.assign({},e),GM.setValue("betterytm-config",JSON.stringify(e))}function U(){return j=Object.assign({},R),GM.setValue("betterytm-config",JSON.stringify(R))}var z,P=function(e,t,n,o){return new(n||(n=Promise))((function(i,r){function l(e){try{a(o.next(e))}catch(e){r(e)}}function s(e){try{a(o.throw(e))}catch(e){r(e)}}function a(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(l,s)}a((o=o.apply(e,t||[])).next())}))};function V(){return P(this,void 0,void 0,(function*(){s(`#betterytm-watermark{color:#fff;cursor:pointer;display:inline-block;font-size:10px;left:45px;position:absolute;text-decoration:none;top:46px;z-index:10}@media(max-width:615px){#betterytm-watermark{display:none}}#betterytm-watermark:hover{text-decoration:underline}.side-panel.modular ytmusic-player-queue-item .song-info.ytmusic-player-queue-item{position:relative}.side-panel.modular ytmusic-player-queue-item .song-info .bytm-queue-btn-container{display:none;position:absolute;right:0}.side-panel.modular ytmusic-player-queue-item:hover .song-info .bytm-queue-btn-container{display:inline-block}#betterytm-lyrics-button{align-items:center;background-color:transparent;border-radius:100%;height:40px;justify-content:center;margin-left:8px;position:relative;vertical-align:middle;width:40px}#betterytm-lyrics-button:hover{background-color:#383838}#betterytm-lyrics-img{display:inline-block;height:24px;padding:5px;width:24px;z-index:10}#bytm-menu-header-container{align-items:center;border-color:#fff;border-style:none solid none none;display:flex;justify-content:flex-start}.bytm-menu-header-option{align-items:center;border-color:#fff;border-style:solid none;display:"flex";justify-content:center}#bytm-menu-header-option h3{margin:0}.bytm-menu-tab[data-active=false],.bytm-menu-tab[data-active=true]{display:none}`,"global");const t=yield H(),n=r();e&&console.log(`BetterYTM: Initializing features for domain '${n}'`);try{if("ytm"===n&&(function(){const t=new MutationObserver((([{addedNodes:t,removedNodes:n,target:o}])=>{(t.length>0||n.length>0)&&(e&&console.info("BetterYTM: Detected queue change - added nodes:",t.length,"- removed nodes:",n.length),a.fire("queueChanged",o))}));t.observe(document.querySelector(".side-panel.modular #contents.ytmusic-player-queue"),{childList:!0}),e&&console.info("BetterYTM: Successfully initialized SiteEvents observers"),c=[t]}(),t.arrowKeySupport&&(document.addEventListener("keydown",d),e&&console.log("BetterYTM: Added key press listener")),t.removeUpgradeTab&&g(),t.watermarkEnabled&&function(){const t=document.createElement("span");t.id="betterytm-watermark",t.className="style-scope ytmusic-nav-bar",t.innerText=i.name,t.title="Open menu",t.addEventListener("click",(()=>function(){const e=document.querySelector("#betterytm-menu-bg");e.style.visibility="visible",e.style.display="block"}())),l(document.querySelector("#left-content"),t),e&&console.log("BetterYTM: Added watermark element:",t)}(),t.geniusLyrics&&$(),t.queueButtons&&function(){a.on("queueChanged",(e=>{for(const t of e.data.childNodes)t.classList.contains("bytm-has-queue-btns")||x(t)}));const e=document.querySelectorAll("#contents.ytmusic-player-queue > ytmusic-player-queue-item");0!==e.length&&e.forEach((e=>x(e)))}(),"number"==typeof t.volumeSliderSize&&v(),t.anchorImprovements,w()),["ytm","yt"].includes(n)){t.switchBetweenSites&&function(t){document.addEventListener("keydown",(n=>{"F9"===n.key&&function(t){var n;try{let o;if("ytm"===t?o="music":"yt"===t&&(o="www"),!o)throw new TypeError(`Unrecognized domain '${t}'`);const{pathname:i,search:l,hash:s}=new URL(location.href),a=null!==(n=function(e=!1){const t=r();try{if("ytm"===t){const e=document.querySelector("#progress-bar");return isNaN(Number(e.value))?null:Number(e.value)}return null}catch(e){return console.error("BetterYTM: Couldn't get video time due to error:",e),null}}())&&void 0!==n?n:0;e&&console.log(`BetterYTM: Found video time of ${a} seconds`);const c=`https://${o}.youtube.com${i}${l.includes("?")?`${l}&t=${a}`:`?t=${a}`}${s}`;console.info(`BetterYTM - switching to domain '${t}' at ${c}`),m(),setImmediate((()=>location.href=c))}catch(e){console.error("BetterYTM: Error while switching site:",e)}}("yt"===t?"ytm":"yt")})),e&&console.log("BetterYTM: Initialized site switch listener")}(n);try{!function(){var t,n;y(this,void 0,void 0,(function*(){const o=document.createElement("div");o.id="betterytm-menu-bg",o.title="Click here to close the menu",o.style.visibility="hidden",o.style.display="none",o.addEventListener("click",(e=>{"betterytm-menu-bg"===e.target.id&&f()}));const r=document.createElement("div");r.title="",r.id="betterytm-menu",r.style.borderRadius="15px",r.style.display="flex",r.style.flexDirection="column",r.style.justifyContent="space-between";const l=document.createElement("div");l.style.padding="8px 20px 15px 8px",l.style.display="flex",l.style.justifyContent="space-between",l.id="betterytm-menu-titlecont";const a=document.createElement("h2");a.id="betterytm-menu-title",a.innerText=`${i.name} - Configuration`;const c=document.createElement("div");c.id="betterytm-menu-linkscont";const d=(e,t,n)=>{const o=document.createElement("a");o.className="betterytm-menu-link",o.rel="noopener noreferrer",o.target="_blank",o.href=t,o.title=n,o.style.marginLeft="10px";const i=document.createElement("img");i.className="betterytm-menu-img",i.src=e,i.style.width="32px",i.style.height="32px",o.appendChild(i),c.appendChild(o)};d(`https://raw.githubusercontent.com/Sv443/BetterYTM/${p}/resources/external/github.png`,i.namespace,`${i.name} on GitHub`),d(`https://raw.githubusercontent.com/Sv443/BetterYTM/${p}/resources/external/greasyfork.png`,"https://greasyfork.org/xyz",`${i.name} on GreasyFork`);const u=document.createElement("img");u.id="betterytm-menu-close",u.src=`https://raw.githubusercontent.com/Sv443/BetterYTM/${p}/resources/icon/close.png`,u.title="Click to close the menu",u.style.marginLeft="50px",u.style.width="32px",u.style.height="32px",u.addEventListener("click",f),c.appendChild(u),l.appendChild(a),l.appendChild(c);const m=document.createElement("div");m.id="betterytm-menu-opts",m.style.display="flex",m.style.flexDirection="column",m.style.overflowY="auto";const h=(t,n,o)=>y(this,void 0,void 0,(function*(){const i=e=>"object"==typeof e?JSON.stringify(e):String(e);e&&console.info(`BetterYTM: Feature config changed, key '${t}' from value '${i(n)}' to '${i(o)}'`);const r=Object.assign({},yield H());r[t]=o,yield I(r),e&&console.log("BetterYTM: Saved feature config changes:\n",yield GM.getValue("betterytm-config"))})),b=yield H();for(const e in b){const o=N[e];if(!o)continue;const{desc:i,type:r,default:l}=o,s=null!==(t=null==o?void 0:o.step)&&void 0!==t?t:void 0,a=b[e],c=null!==(n=null!=a?a:l)&&void 0!==n?n:void 0,d=document.createElement("div");d.id=`betterytm-ftconf-${e}`,d.style.display="flex",d.style.flexDirection="row",d.style.justifyContent="space-between",d.style.padding="8px 20px";{const e=document.createElement("span");e.style.display="inline-block",e.style.fontSize="15px",e.innerText=i,d.appendChild(e)}{let t="text";switch(r){case"toggle":t="checkbox";break;case"slider":t="range";break;case"number":t="number"}const n=`betterytm-ftconf-${e}-input`,i=document.createElement("span");i.style.display="inline-block",i.style.whiteSpace="nowrap";const a=document.createElement("input");a.id=n,a.style.marginRight="37px",a.type=t,"toggle"===r&&(a.style.marginLeft="5px"),void 0!==c&&(a.value=String(c)),"number"===r&&s&&(a.step=s),o.min&&o.max&&(a.min=o.min,a.max=o.max),"toggle"===r&&void 0!==c&&(a.checked=Boolean(c));const u=(null==o?void 0:o.unit)?" "+o.unit:"",m=e=>String(e).trim(),y=e=>e?"On":"Off";let p;"slider"===r?(p=document.createElement("label"),p.classList.add("betterytm-ftconf-label"),p.style.marginRight="20px",p.style.fontSize="16px",p.htmlFor=n,p.innerText=m(c)+u,a.addEventListener("input",(()=>{p&&(p.innerText=m(parseInt(a.value)))}))):"toggle"===r&&(p=document.createElement("label"),p.classList.add("betterytm-ftconf-label"),p.style.paddingLeft="10px",p.style.paddingRight="5px",p.style.fontSize="16px",p.htmlFor=n,p.innerText=y(Boolean(c))+u,a.addEventListener("input",(()=>{p&&(p.innerText=y(a.checked)+u)}))),a.addEventListener("input",(()=>{let t=parseInt(a.value);isNaN(t)&&(t=Number(a.value)),void 0!==c&&h(e,c,"toggle"!==r?t:a.checked)}));const f=document.createElement("button");f.innerText="Reset",f.addEventListener("click",(()=>{a["toggle"!==r?"value":"checked"]=l,p&&(p.innerText="toggle"===r?y(a.checked)+u:m(parseInt(a.value))+u),void 0!==c&&h(e,c,l)})),p&&i.appendChild(p),i.appendChild(a),i.appendChild(f),d.appendChild(i)}m.appendChild(d)}const g=document.createElement("div");g.id="betterytm-menu-footer",g.style.marginTop="20px",g.style.fontSize="17px",g.style.textDecoration="underline",g.style.padding="10px 20px",g.style.position="sticky",g.style.backgroundColor="var(--bytm-menu-bg)",g.style.bottom="0",g.innerText="You need to reload the page to apply changes.";const v=document.createElement("button");v.style.marginLeft="20px",v.innerText="Reload now",v.title="Click to reload the page",v.addEventListener("click",(()=>location.reload())),g.appendChild(v),m.appendChild(g);const w=document.createElement("div");w.id="betterytm-menu-body",w.appendChild(l),w.appendChild(m);const x=document.createElement("div");x.style.display="flex",x.style.justifyContent="space-around",x.style.fontSize="1.15em",x.style.marginTop="10px",x.style.marginBottom="5px";const T=document.createElement("span");T.id="betterytm-menu-version",T.innerText=`v${i.version}`,x.appendChild(T),m.appendChild(x),r.appendChild(w),r.appendChild(x),o.appendChild(r),document.body.appendChild(o),e&&console.log("BetterYTM: Added menu elem:",o),s(':root {\n  --bytm-menu-bg: #212121;\n}\n\n#betterytm-menu-bg {\n  display: block;\n  position: fixed;\n  width: 100vw;\n  height: 100vh;\n  top: 0;\n  left: 0;\n  z-index: 15;\n  background-color: rgba(0, 0, 0, 0.6);\n}\n\n/* TODO:FIXME: needs better positioning (vw and vh === "big no no") */\n#betterytm-menu {\n  display: inline-block;\n  position: fixed;\n  width: 50vw;\n  height: auto;\n  left: 25vw;\n  top: 10vh;\n  z-index: 16;\n  padding: 8px;\n  color: #fff;\n  background-color: var(--bytm-menu-bg);\n}\n\n#betterytm-menu-opts {\n  max-height: 70vh;\n  overflow: auto;\n}\n\n#betterytm-menu-titlecont {\n  display: flex;\n}\n\n#betterytm-menu-title {\n  font-size: 20px;\n  margin-top: 5px;\n  margin-bottom: 8px;\n}\n\n#betterytm-menu-linkscont {\n  display: flex;\n}\n\n.betterytm-menu-link {\n  display: inline-block;\n}\n\n/*.betterytm-menu-img {\n\n}*/\n\n#betterytm-menu-close {\n  cursor: pointer;\n}\n\n.betterytm-ftconf-label {\n  user-select: none;\n}',"menu")}))}()}catch(e){console.error("BetterYTM: Couldn't add menu:",e)}}}catch(e){console.error("BetterYTM: General error while executing feature:",e)}}))}console.log(`${i.name} v${i.version} (${i.lastCommit}) - ${i.namespace}`),console.log(`Powered by lots of ambition and my song metadata API: ${S}`),Error.stackTraceLimit=1/0,z=window.__proto__.addEventListener,window.__proto__.addEventListener=function(...e){const[t,n,...o]=e;return"beforeunload"===t?z.apply(this,[t,(...e)=>{u&&n(...e)},...o]):z.apply(this,e)},H().then((e=>{e.disableBeforeUnloadPopup&&m()})),function(){P(this,void 0,void 0,(function*(){yield function(){return e=this,t=void 0,o=function*(){h=yield H()},new((n=void 0)||(n=Promise))((function(i,r){function l(e){try{a(o.next(e))}catch(e){r(e)}}function s(e){try{a(o.throw(e))}catch(e){r(e)}}function a(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(l,s)}a((o=o.apply(e,t||[])).next())}));var e,t,n,o}();try{document.addEventListener("DOMContentLoaded",V)}catch(e){console.error("BetterYTM - General Error:",e)}try{document.addEventListener("DOMContentLoaded",(()=>{const e=document.createElement("div");e.id="bytm-menu-container",e.innerHTML='<dialog id="bytm-menu-dialog"> <div id="bytm-menu-header-container"> <div class="bytm-menu-header-option" id="bytm-menu-tab-options-header" data-active="true"> <h3>Options</h3> </div> <div class="bytm-menu-header-option" id="bytm-menu-tab-info-header" data-active="false"> <h3>Info</h3> </div> <div class="bytm-menu-header-option" id="bytm-menu-tab-changelog-header" data-active="false"> <h3>Changelog</h3> </div> </div> <div id="bytm-menu-body"> <div class="bytm-menu-tab-content" id="bytm-menu-tab-options-content" data-active="true"></div> <div class="bytm-menu-tab-content" id="bytm-menu-tab-info-content" data-active="false"> ayo info </div> <div class="bytm-menu-tab-content" id="bytm-menu-tab-changelog-content" data-active="false"></div> </div> </dialog> ',document.body.appendChild(e),q()}))}catch(e){console.error("BetterYTM: Couldn't initialize menu:",e)}}))}()}()}();
//# sourceMappingURL=BetterYTM.user.js.map
